/*
 * LinuxWorld retrieval tool.
 *
 * (C) 1999 Alan Cox.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>

#include "config.h"
#include "engine.h"
#include "portaloo.h"


#define MARKER "<TABLE CELLSPACING=\"0\" BORDER=\"0\" CELLPADDING=\"2\"><TR><td WIDTH=\"10\" BGCOLOR=\"#ccccff\" VALIGN=\"top\">&nbsp;</td><td BGCOLOR=\"#ffffff\" VALIGN=\"top\"><FONT face=\"Arial,Helvetica,Sans-serif\">"

int main(int argc, char *argv[])
{
	int s;
	int head=1;
	int ct=0;	
	char *p;
	char buf[256];
	char base[256];
	FILE *f;
	
	if(argc!=2)
	{
		fprintf(stderr,"%s [num]\n", argv[0]);
		exit(1);
	}	
	snprintf(buf, sizeof(buf), "%s/%s.new", PORTALOO_BASE,  argv[1]);
	snprintf(base, sizeof(buf), "%s/%s.out",PORTALOO_BASE,  argv[1]);
	
	f=fopen(buf, "w");
	if(f==NULL)
	{
		perror(buf);
		exit(1);
	}
	
	s=host_connect("www.linuxworld.com",80);
	if(s==-1)
		return 1;
	
	host_get(s,"www.linuxworld.com", "/");
	
	fprintf(f,"Linux World Net News\nhttp://www.linuxworld.com\nLinux World: Net News\n--\n");
	fprintf(f,"<br clear=all><FONT size=\"-1\" face=\"helvetica\"><P><UL>\n");
	
	while((p=host_readline(s))!=NULL)
	{
		char *app;
		if(head && *p!=0 && *p!='\r')
			continue;
		
		if(head)
		{		
			head = 0;
			continue;
		}
		
		if(memcmp(p, MARKER, strlen(MARKER)))
			continue;
		
		app=p+strlen(MARKER);
		
		/* Now we process their dumb single giant line */
		while(1)
		{
			int last=0;
			char *uptr;
			if(strstr(app, "</table>"))
				last=1;
			while(*app && memcmp(app, "<a href=\"", 9))
				app++;
			if(*app==0)
			{
				if(last)
					break;
				app=host_readline(s);
				continue;
			}
			uptr=app;
			
			while(*app && memcmp(app, "</a>", 4))
				app++;
			app[4]=0;
			app+=5;
			fprintf(f,"<LI>%s\n", uptr);
			ct++;
			if(ct==7)
				fprintf(f,"--\n");
		}
	}
	fprintf(f,"</UL></FONT>\n");
	fclose(f);
	if(rename(buf,base)==-1)
	{
		perror("rename");
		exit(1);
	}
	exit(0);
}
	
