/*
 * Quote retrieval tool.
 *
 * (C) 1998 Alan Cox.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>

#include "config.h"
#include "engine.h"
#include "portaloo.h"
 

int main(int argc, char *argv[])
{
	int s;
	int head=1;
	int ct=0;	
	char *p;
	char buf[256];
	char base[256];
	char tmp[256];
	FILE *f;
	char *stock_code;
	char *stock_name;
	
	if(argc!=4)
	{
		fprintf(stderr,"%s [num] [code] [name]\n", argv[0]);
		exit(1);
	}	
	
	stock_code=argv[2];
	stock_name=argv[3];
	
	snprintf(buf, sizeof(buf), PORTALOO_BASE"%s.new", argv[1]);
	snprintf(base, sizeof(buf), PORTALOO_BASE"%s.out", argv[1]);
	
	f=fopen(buf, "w");
	if(f==NULL)
	{
		perror(buf);
		exit(1);
	}
	
	s=host_connect("quote.yahoo.com",80);
	if(s==-1)
		return 1;
	
	snprintf(tmp, 256, "/d/quotes.csv?f=sl1d1t1c1ohgv&e=.csv&s=%s", stock_code);
	host_get(s, tmp, "quote.yahoo.com");
	
	fprintf(f,"%s Stock\nhttp://quote.yahoo.com\nYahoo: %s Stock\n--\n", stock_name, stock_name);
	fprintf(f,"<br clear=all><FONT size=\"-1\" face=\"helvetica\"><P>\n");
	
	while((p=host_readline(s))!=NULL)
	{
		char *app;
		char *prc;
		char *time;
		char *shift;
		if(head && *p!=0 && *p!='\r')
			continue;
		
		if(head)
		{		
			head = 0;
			continue;
		}
	
		p++;	
		app=strchr(p,'"');
		if(app==NULL)
			continue;
		*app=0;
		app+=2;
		prc=app;
		app=strchr(app, ',');
		if(app==NULL)
			continue;
		*app++=0;
		app=strchr(app, ',');
		if(app==NULL)
			continue;
		/* Ok we are now at the time */
		app++;
		if(*app!='"')
			continue;
		app++;	/* " */	
		time=app;
		app=strchr(app,'"');
		if(app==NULL)
			continue;
		*app=0;
		app+=2;
		shift=app;
		
		app=strchr(app, ',');
		if(app==NULL)
			continue;
		*app=0;
		
		fprintf(f,"<CENTER><FONT size=+2>%s</FONT> <FONT size=-1>at %s</FONT><br><br>\n",
			stock_code, time);
		fprintf(f,"<br><br><br><FONT size=+2>%s&nbsp;", prc);
		if(*shift=='-')
			fprintf(f,"<FONT color=red>");
		else if(*shift=='+')
			fprintf(f,"<FONT color=green>");
		else fprintf(f,"<FONT color=blue>");
		fprintf(f,"%s</FONT></FONT></CENTER><br>\n", shift);		
	}
	fprintf(f,"</FONT>\n");
	fclose(f);
	if(rename(buf,base)==-1)
	{
		perror("rename");
		exit(1);
	}
	exit(0);
}
	