/*
 * Register retrieval tool.
 *
 * (C) 1999 Alan Cox.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>

#include "config.h"
#include "engine.h"
#include "portaloo.h"

int main(int argc, char *argv[])
{
	int s;
	int head=1;
	int ct=0;	
	char *p;
	char buf[256];
	char base[256];
	char now[9];
	int c;
	FILE *f;
	int mode=0;
	struct tm *tm;
	time_t tick;
	int strobe=0;
	
	time(&tick);
	tm=gmtime(&tick);
	if(tm==NULL)
	{
		fprintf(stderr, "%s: invalid time.\n", argv[0]);
		exit(1);
	}
	
	snprintf(now, 9, "%02d%02d%02d%02d",
		tm->tm_mon+1, tm->tm_mday,
		tm->tm_mon+1, tm->tm_mday-1);
		
	
	if(argc!=2)
	{
		fprintf(stderr,"%s [num]\n", argv[0]);
		exit(1);
	}	
	snprintf(buf, sizeof(buf), PORTALOO_BASE"%s.new", argv[1]);
	snprintf(base, sizeof(buf), PORTALOO_BASE"%s.out", argv[1]);
	
	f=fopen(buf, "w");
	if(f==NULL)
	{
		perror(buf);
		exit(1);
	}
	
	s=host_connect("www.theregister.co.uk",80);
	if(s==-1)
		return 1;
	
	host_get(s,"www.theregister.co.uk", "/");
	
	fprintf(f,"The Register\nhttp://www.theregister.co.uk\nThe Register\n--\n");
	fprintf(f,"<br clear=all><FONT size=\"-1\" face=\"helvetica\"><P><UL>\n");
	
	while((p=host_readline(s))!=NULL)
	{
		char *app;
		if(head && *p!=0 && *p!='\r')
			continue;
		
		if(head)
		{		
			head = 0;
			break;
		}
	}
	/* Hunt for /content/ */

	while((c=host_readchar(s))!=EOF)
	{
//		if(mode>1)printf("IN C='%c' mode=%d\n", c, mode);
		if(mode<9)
		{
			if(c=='\r' || c=='\n')
				continue;
			if(c=="/content/"[mode])
				mode++;
			else
				mode=0;
		
			if(mode==9)
			{
				strobe=1-strobe;
				if(strobe==0)
				{
					mode=0;
					continue;
				}
				fprintf(f,"<LI><A href=\"http://www.theregister.co.uk/content/");
			}
			continue;
		}
		
		if(mode==9)
		{
			if(c=='\'' || c=='\"')
			{
				fprintf(f, "\">");
				mode++;
			}
			else fprintf(f,"%c", c);
			continue;
		}
		if(mode==10)
		{
			/* URL ended */
			if(c=='G')
				mode++;
			continue;
		}
		if(mode==11)
		{
			if(c!='>')
				mode=10;
			else
				mode=12;
			continue;
		}
		if(mode==12)
		{
			if(c=='<')
				mode=13;
			else
				fprintf(f,"%c",c);
			continue;
		}
			
		if(mode==13)
		{
			if(c=='/')
				mode=14;
			else
			{
				fprintf(f,"<%c",c);
				mode=12;
			}
			continue;
		}
			
		if(mode==14)
		{
			if(c=='S')
			{
				fprintf(f,"</A>\n");
				ct++;
				if(ct==10)
					fprintf(f,"--\n");
				mode=0;
				continue;
			}
			fprintf(f,"</%c",c);
			mode=12;
			continue;
		}
		
		fprintf(stderr, "BAD MODE %d\n", mode);	
	}
	fprintf(f,"</UL></FONT>\n");
	fclose(f);
	if(rename(buf,base)==-1)
	{
		perror("rename");
		exit(1);
	}
	exit(0);
}
	
	