#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <readline/readline.h>

#include "config.h"
#include "struct.h"

int main(int argc, char **argv)
{
	char path[513];
	struct Header msg;
	int f, ff;
	char *c;
	int id;
	time_t tick;
	

	if (argc!=1)
	{
		printf("Usage: add\n");
		exit(0);
	}

	time(&tick);
	
	snprintf(path, 512, "%s/%ld.i", HOMEPATH, tick);

	if ((f=open(path, O_RDONLY))<0)
	{
		id=0;
	}else
	{
		lseek ( f, -1 * sizeof(msg), SEEK_END);
		read (f, &msg, sizeof(msg));
		id=msg.Ref + 1;
		close(f);
	}

	if ((f=open(path, O_WRONLY|O_APPEND|O_CREAT, 0644))<0)
	{
		fprintf(stderr, "Cannot open %s: %s\n", path, strerror(errno));
		exit(0);
	}
	
	snprintf(path, 512, "%s/%ld.t", HOMEPATH, tick);
	if ((ff=open(path, O_WRONLY|O_APPEND|O_CREAT, 0644))<0)
	{
		fprintf(stderr, "Cannot open %s: %s\n", path, strerror(errno));
		exit(0);
	}
	
	if (id==0)
		printf("Creating base article for %ld\n",tick);
	else
		printf("Adding comment %d in %ld\n", id, tick);


	c=readline("From: ");
	strncpy(msg.from, c, NAMESIZE);	
	msg.from[NAMESIZE]=0;
	
	c=readline("Subject: ");
	strncpy(msg.subject, c, SUBJECTSIZE);	
	msg.from[SUBJECTSIZE]=0;

	c=readline("Reply to: ");
	if (c==NULL || *c=='\n') msg.replyto=0;
	else msg.replyto=atoi(c);

	c=readline("Icon: ");
	if (c==NULL || *c=='\n') msg.icon=0;
	else msg.icon=atoi(c);

	msg.date=time(0);
	msg.status=1;
	msg.Ref=id;
	
	c=readline("Body: ");
	msg.size=strlen(c);
	msg.datafield=lseek(ff, 0, SEEK_END);
	
	write(f, &msg, sizeof(msg));
	write(ff, c, msg.size);

	close(ff);
	close(f);
}
	

