#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include "config.h"
#include "struct.h"
#include "proto.h"
#include "portaloo.h"
#include "thread.h"

char *html_header=NULL;
char *html_footer=NULL;

extern char *thread_folder;

static char *html_tmp;

char *html_filter(char *p)
{
	char *in, *out;
	if(html_tmp)
		free(html_tmp);
	html_tmp=malloc(5*strlen(p));
	if(html_tmp==NULL)
		return "Out of memory";
		
	in=p;
	out=html_tmp;
	while(*in)
	{
		if(*in=='&')
		{
			strcpy(out, "&amp;");
			out+=5;
		}
		else if(*in=='<')
		{
			strcpy(out, "&lt;");
			out+=4;
		}
		else if(*in=='>')
		{
			strcpy(out, "&gt;");
			out+=4;
		}
		else 
		{
			*out=*in;
			out++;
		}
		in++;
	}
	*out=0;
	return html_tmp;
}

char *html_strncpy(char *p1, char *p2, int len)
{
	return strncpy(p1, html_filter(p2), len);
}
	
static void article_include(void)
{
	char path[513];
	char entry[128];
	FILE *foldp;
	struct Header fol;
	int fi;
	char *op=thread_folder;

	snprintf(path, 512, "%s/running.articles", HOMEPATH);
	foldp=fopen(path, "r");
	if(foldp==NULL)
		html_error("list_folders: opening folder.bb");


	printf("<b>Today's Stories</b>\n");
	printf("<FONT face=helvetica size=-1><UL>\n");
	fflush(stdout);

	while (fgets(entry, 128, foldp)!=NULL)
	{
		char *p=strchr(entry, '\n');
		if(p)
			*p=0;
		snprintf(path, 512, "%s/%s.i", HOMEPATH, entry);
		if ((fi=open(path, O_RDONLY))<0) 
			continue;
		read(fi, &fol, sizeof(fol));
		printf("<LI><a href=\"%s?fol=%s\">\n",
			CGIPATH, entry);
		thread_folder=entry;
		article_full( fol, 0, 0, 1);	
		printf("</a>\n");
		close(fi);
	}
	thread_folder=op;
	printf("</UL></FONT>\n");
	fclose(foldp);
}


void print_header(char *title)
{
	FILE *ff;
	char buff[1024];

/*	printf("Content-type: text/html\n"); */
	printf("\n");

	if (html_header!=NULL)
		snprintf(buff,1024,"%s/html/%s",HOMEPATH,html_header);
	else
		snprintf(buff,1024,"%s/html/%s",HOMEPATH,HTML_header);
	if ((ff=fopen(buff,"r"))==NULL)
	{
		default_header(title);
		return;
	}

	while (!feof(ff) && fgets(buff,1023,ff)!=NULL)
	{
		if (strstr(buff,"%%")!=NULL)
		{
			char *c, *x;

			c=buff;
			while ((x=strstr(c,"%%"))!=NULL)
			{
				*x=0;
				printf("%s",c);
				x+=2;
				if (*x=='t') 
					printf("%s",title);
				else if (*x=='l') 
					print_login(-1);
				else if (*x=='L') 
					print_login(0);
				else if (*x=='r') 
				{
					int n;
					sscanf(x+1, "%d", &n);
					rdf_include(n);
				}
				else if (*x=='s')
					article_include();
				else if (*x==0) 
					break;
			
				if (x[1]==0 || x[2]==0) break;

				c=x;
				if ((x=strstr(c,"%%"))!=NULL)
					c=x+2;
			}
			printf("%s",c);
		}else
			printf("%s",buff);
	}
	fclose(ff);
	return;
}

void default_header(char *title)
{
	printf("<html><head>\n");
	printf("<title>%s</title>\n",title);
	printf("</head>\n\n");
	printf("<body>\n");
	printf("<center><h2>%s</h2></center>\n\n",title);
}

void default_footer(void)
{
	printf("</body></html>\n");
}

void html_error(char *mesg)
{
	printf("Content-type: text/html\n");
#ifdef WELSH
	print_header("Gwall");
	printf("<h2>Darganfyddwyd gwall</h2>\n");
#else
	print_header("Error");
	printf("<h2>An Error has occured</h2>\n");
#endif
	if (mesg!=NULL) printf("<h4>%s</h4>\n",mesg);
	if (errno!=0) printf(" errno=%d '%s'<br>\n", errno, strerror(errno));
	print_footer();
	exit(0);
}

void print_footer(void)
{
	FILE *ff;
	char buff[1024];

	if (html_footer!=NULL)
		snprintf(buff,1024,"%s/html/%s",HOMEPATH,html_footer);	
	else
		snprintf(buff,1024,"%s/html/%s",HOMEPATH,HTML_footer);
	if ((ff=fopen(buff,"r"))==NULL)
	{
		default_footer();
		return;
	}

	while (!feof(ff) && fgets(buff,1023,ff)!=NULL)
	{
		if (strstr(buff,"%%")!=NULL)
		{
			char *c, *x;

			c=buff;
			while ((x=strstr(c,"%%"))!=NULL)
			{
				*x=0;
				printf("%s",c);
				x+=2;
				if (*x=='c') 
					print_copyright();
				else if (*x=='L')
					print_login(0);
				else if (*x=='l') 
					print_login(-1);
				else if (*x=='r')
				{
					int n;
					sscanf(x+1, "%d", &n);
					rdf_include(n);
				}
				else if (*x==0) 
					break;
			
				if (x[1]==0 || x[2]==0)
					break;

				c=x;
				if ((x=strstr(c,"%%"))!=NULL)
					c=x+2;
			}
			printf("%s",c);
		}else
			printf("%s",buff);
	}
	fclose(ff);
	return;
}

void print_copyright(void)
{
	printf("<br>");
#ifdef WELSH
	printf("<FONT face=\"helvetica\" size=-1>Portaloo Web Portal");
	printf("<A href=\"mailto:alan@redhat.com\">Alan Cox</A>, <br>");
	printf("<A href=\"mailto:justin@discordia.org.uk\">Justin Mitchell</A>, <br>");
	printf("&copy; Hawlfraint 1999 ");
	printf("<A href=\"http:///\">Discordia UK</A>");
	printf("Cedwir yr holl hawliau.");
#else
	printf("<FONT face=\"helvetica\" size=-1>Portaloo Web Portal");
	printf("<A href=\"mailto:alan@redhat.com\">Alan Cox</A>, <br>");
	printf("<A href=\"mailto:justin@discordia.org.uk\">Justin Mitchell</A>, <br>");
	printf("&copy; Copyright 1999 ");
	printf("<A href=\"http://discordia.org.uk/\">Discordia UK</A>");
	printf("All rights reserved.");
#endif
	printf("</FONT>");
}
