#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>

#include "config.h"
#include "struct.h"
#include "cgi.h"
#include "portaloo.h"
#include "proto.h"
#include "thread.h"
#include "md5.h"

extern  char *thread_folder;
extern  int thread_size;
extern FILE *debug;
extern char *html_header;
extern char *html_footer;


int f_active(int stat)
{
	if (stat&1)
		return(TRUE);
	else
		return(FALSE);
}

void list_folders(int depth)
{
	char path[513];
	char entry[128];
	FILE *foldp;
	struct Header fol;
	int fi;

	snprintf(path, 512, "%s/running.articles", HOMEPATH);
	foldp=fopen(path, "r");
	if(foldp==NULL)
		html_error("list_folders: opening folder.bb");


	html_header="front_head.html";
	html_footer="front_foot.html";
	print_header("Portaloo: Today");

	while (fgets(entry, 128, foldp)!=NULL)
	{
		char *p=strchr(entry, '\n');
		if(p)
			*p=0;
		snprintf(path, 512, "%s/%s.i", HOMEPATH, entry);
		if ((fi=open(path, O_RDONLY))<0) 
			continue;
		read(fi, &fol, sizeof(fol));
		thread_folder=entry;
		article_full( fol, 0, 0, 0);	
		printf("<br><br><a href=\"%s?fol=%s\">%s</a>\n",
			CGIPATH, entry, "Read More...");
		lseek(fi, -1 * sizeof(fol), SEEK_END);
		read(fi, &fol, sizeof(fol));
		if (fol.Ref > 0)
			printf("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%d Comment(s).", fol.Ref);
		printf("<br><br></td></tr></table>\n");
		close(fi);
	}
	fclose(foldp);
	print_footer();
	exit(0);
}

void get_an_account(char *err)
{
	print_header("Portaloo: Login and Accounts");
	printf("<TABLE width=99%% cellspacing=0><TR><TD bgcolor=\"#000000\" width=99%%>\n");
	printf("<FONT face=helvetica size=+1 color=white><B>Request an Account</B></FONT>\n");
	printf("</TR></TD><TR><TD>\n");
	printf("<FONT face=helvetica>\n");
	if(err)
		printf("%s\n<P>\n", err);
	printf("Portaloo requires a valid login for several services. In paticular you may \n");
	printf("not post to the system without a valid account. To get an account you need to \n");
	printf("give a valid email address. The system will then mail you a password to use for \n");
	printf("the portaloo.\n");
	printf("<P>\n");
	printf("<B><U>Privacy</U></B><br>\n");
	printf("Portaloo tracks users only for authentication purposes. We log email addresses only \n");
	printf("to prevent abuse of the system. We do not sell or give out email addresses. We will \n");
	printf("provide email addresses to law enforcement bodies in the event of a criminal investigation.\n");
	printf("<P>\n");
	printf("<B><U>Terms and Conditions</U></B><br>\n");
	printf("The Portaloo service is provided without warranty or guarantee of future service. The \n");
	printf("site administration reserve the right to delete and/or edit material as they see fit. \n");
	printf("<P>\n");
	printf("User agrees to indemnify the Portaloo service against any actions arising from their \n");
	printf("use or misuse of the service. User will not post material of an offensive, threatening, \n");
	printf("obscene, libellous or otherwise illegal or actionable nature.\n");
	printf("<P>\n");
	printf("By requesting an account User accepts these terms and conditions.\n");
	printf("<P>\n");
	printf("<A href=\"%s\"><B>Refuse conditions</B></A>\n", CGIPATH);
	printf("<P><P>\n");
	printf("<form action=%s method=get>\n", CGIPATH);
	printf("<input type=hidden name=new_user value=request>\n");
	printf("<table border=0 width=99%%>\n");
	printf("<tr><td width=20%%>");
	printf("<font face=helvetica>\n");
	printf("Nickname: </TD><TD><input type=text name=username size=16 maxsize=16>\n");
	printf("</tr</td><tr><td>");
	printf("<font face=helvetica>\n");
	printf("Email Address: </TD><TD><input type=text name=email size=30 maxsize=128>\n");
	printf("</td></tr><tr><td><INPUT type=submit value=\"Accept Conditions\"></tr></td>\n");
	printf("</font>\n");
	printf("<td></tr>\n");
	printf("</table>\n");
	printf("</form>\n");
	printf("<br><br>\n");
	printf("<b><u>Lost your password ?</u></b><br>\n");
	printf("Enter your username and we will mail it to the email address given. \n");
	printf("<P>\n");
	printf("<form action=%s method=get>\n", CGIPATH);
	printf("<input type=hidden name=new_user value=stupid>\n");
	printf("<table border=0 width=99%%>\n");
	printf("<tr><td width=20%%>");
	printf("<font face=helvetica>\n");
	printf("Nickname: </TD><TD><input type=text name=username size=16 maxsize=16>\n");
	printf("</td></tr><tr><td align=left><INPUT type=submit value=\"Send Password\"></tr></td>\n");
	printf("</font>\n");
	printf("<td></tr>\n");
	printf("</table>\n");
	printf("</form>\n");
	printf("</FONT></TR></TD></TABLE>\n");
	print_footer();
}

/*
 *	Check for bad names, canonicalise good ones
 */
 
static int bad_name(char *p)
{	
	char *bp=p;
	if(strlen(p)<3||strlen(p)>15)
		return 1;
	for(;*p;p++)
	{
		if(isalpha(*p))
		{
			if(p==bp)
				*p=toupper(*p);
			else
				*p=tolower(*p);
			continue;
		}
		if(isdigit(*p))
			continue;
		return 1;
	}
	return 0;
}

FILE *debug;

int main()
{
	int j;
	char *c, *p;
	char *fol,*msg, *action;
	int depth=0;
	int replay=0;

	if ((debug=fopen("/tmp/portal","a"))==NULL) debug=stderr;

	printf("Content-type: text/html\n");

	cgi_process();
	
	fprintf(debug, "---------------------begin-------------------\n");

	if(load_secret()<0)
	{
		printf("\nNo/bad secret.\n");
		exit(1);
	}
	
	p=getenv("HTTP_COOKIE");
	if(p==NULL)
	{
		fprintf(debug, "new cookie\n");
		init_portaloo(&self, "unset");
	}
	else
	{
		switch(decode_portaloo_cookie(&self, p))
		{
			case -1:
			case 0:
				init_portaloo(&self, "broken");
				break;
			default:
				if(strcmp(self.uname, "broken")==0)
					strcpy(self.uname, "unset-ok");
		}
	}
	

	depth=self.count[DEPTH_COUNT];
	
	fprintf(debug, "Issued at %s", ctime(&self.laston));
	fprintf(debug, "self.count depth = %d\n", depth);
	fprintf(debug, "name=%s\n", self.uname);
	fprintf(debug, "flags0=%d\n", self.flags[0]);

	if ((c=cgi_find("depth"))!=NULL)
		self.count[DEPTH_COUNT] = depth = atoi(c);

	fprintf(debug, "Issuing depth=%d\n", self.count[DEPTH_COUNT]);

	if ((c=cgi_find("new_user"))!=NULL)
	{
		if(strcasecmp(c, "form")==0)
		{
			get_an_account(NULL);
			exit(1);
		}
		if(strcasecmp(c, "request")==0)
		{
			char *u=cgi_find("username");
			char *em=cgi_find("email");
			if(u==NULL || em==NULL)
			{
				get_an_account(NULL);
				exit(1);
			}
			if(bad_name(u))
			{
				get_an_account("The username must contain letters and numbers only. It must be at least 3 letters long and no more than sixteen.\n");
				exit(1);
			}
			if(!strchr(em,'@'))
			{	
				get_an_account("The email field appears invalid.\n");
				exit(1);
			}
			if(strcasecmp(u, "cypherpunks")==0)
			{
				get_an_account("Guess again.\n");
				exit(1);
			}
			if(user_add(u, em)==-1)
			{
				get_an_account("That username is already taken. Try another.\n");
				exit(1);
			}
		}
		if(strcasecmp(c, "stupid")==0)
		{
			char *u=cgi_find("username");
			if(u==NULL || bad_name(u))
			{
				get_an_account("The username given is invalid.\n");
				exit(1);
			}
			if(user_lost(u)==-1)
			{
				get_an_account("I cannot find this username.\n");
				exit(1);
			}
		}
	}
	if ((c=cgi_find("cookie_user"))!=NULL)
	{
		if (!strcasecmp(c, "logout"))
		{
			self.flags[0]&=~FLAGS0_NAME_SET;
		}
		/* set a session cookie, then continue */
		else if (!strcasecmp(c, "login"))
		{
			char *u, *p;
			if ((u=cgi_find("username"))!=NULL
			&& (p=cgi_find("password"))!=NULL
			&& !bad_name(u) &&user_valid(u,p) )
			{
				strcpy(self.uname, cgi_find("username"));
				self.flags[0]|=FLAGS0_NAME_SET;
			}
			else
			{
				if(u && bad_name(u))
					get_an_account("The username you entered is not valid.");
				else
					get_an_account("Invalid password. If you don't have an account now is the time to apply for one.");
				exit(0);
			}
		}
	}
	
	if((action=cgi_find("action"))!=NULL)
	{
		fprintf(debug, "Adding\n");
		if(strcasecmp(action, "add")==0)
		{
			int v;
			char *p=cgi_find("clock");
			if(p==NULL)
			{
				print_header("Portaloo: invalid comment post");
				printf("<p>Your web browser failed to provide all the variables.\n");
				print_footer();
				exit(0);
			}
			sscanf(p,"%d", &v);
			fprintf(debug, "%d %d\n", v, self.count[POST_COUNT]);
			if(v!=self.count[POST_COUNT])
				replay=1;
			self.count[POST_COUNT]++;
		}
	}

	issue_portaloo_cookie(&self);

	if ((fol=cgi_find("fol"))==NULL)
		list_folders(depth);
	
	if ((action=cgi_find("action"))!=NULL)
	{
		if (!strcasecmp(action, "comment"))
		{
			j=load_thread(fol);
			if ((c=cgi_find("replyto"))!=NULL)
				add_comment_request(atoi(c), fol);
		}
		else if (!strcasecmp(action, "add"))
		{
			j=load_thread(fol);
			if(replay==0)
				add_comment(fol);
		}
	}

	if ((msg=cgi_find("msg"))==NULL)
	{
		j=load_thread(fol);
		show_thread(j, depth, 0);
	}
	else
	{
		int id;
		id=atoi(msg);
		j=load_thread(fol);
		show_thread(j, depth, id);
	}
	
	fprintf(debug, "done\n");
	fclose(debug);

	exit(0);
}

