#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>

#include "config.h"
#include "cgi.h"
#include "portaloo.h"
#include "proto.h"

static void print_file (char *p)
{
	char buf[1024];
	FILE *f=fopen(p, "r");
	if(f==NULL)
		return;
	while(fgets(buf, 1024, f))
		fputs(buf, stdout);
	fclose(f);
}


int main(int argc, char *argv[])
{
	char *c, *p;
	int reload = 1;
	int chan = 0;
	int nc;
	int pc;
	
	printf("Content-type: text/html\n");

	cgi_process();
	
	if(load_secret()<0)
	{
		printf("\nNo/bad secret.\n");
		exit(1);
	}
	
	p=getenv("HTTP_COOKIE");
	if(p==NULL)
	{
		init_portaloo(&self, "unset");
	}
	else
	{
		switch(decode_portaloo_cookie(&self, p))
		{
			case -1:
			case 0:
				init_portaloo(&self, "broken");
				break;
			default:
				if(strcmp(self.uname, "broken")==0)
					strcpy(self.uname, "unset-ok");
		}
	}
	

	if ((c=cgi_find("channel"))!=NULL)
	{
		sscanf(c, "%d", &chan);
		if(chan<0 || chan >= MAX_SUBSCRIBED || self.subscribed[chan]==0)
			chan = 0;
	}

	if ((c=cgi_find("reload"))!=NULL)
	{
		sscanf(c, "%d", &reload);
	}

	nc=chan+1;
	if(nc>= MAX_SUBSCRIBED || self.subscribed[nc]==0)
		nc = 0;
		
	pc=chan-1;
	if(pc<0)
	{
		int i;
		for(i=0;i<MAX_SUBSCRIBED;i++)
		{
			if(self.subscribed[i]==0)
				break;
		}
		pc = i-1;
	}
	
	if(reload)
	{
		printf("Refresh: 30; URL="TOOLBAR_CGI"?reload=%d&channel=%d\n",
			reload, reload==1?nc:pc);
	}

	printf("\n");

	print_file(HOMEPATH"/html/toolbar.top");
	printf("<A href=\""TOOLBAR_CGI"?reload=-1&channel=%d\">[&lt;&lt;]",pc);
	printf("</A>&nbsp;<A href="TOOLBAR_CGI"?reload=0&channel=%d\">[&lt;]",pc);
	printf("</A>&nbsp;<A href="TOOLBAR_CGI"?reload=0&channel=%d\">[=]",chan);
	printf("</A>&nbsp;<A href="TOOLBAR_CGI"?reload=0&channel=%d\">[&gt;]",nc);
	printf("</A>&nbsp;<A href="TOOLBAR_CGI"?reload=1&channel=%d\">[&gt;&gt;]",nc);
	printf("</A><br>\n");
	
	/*
	 *	Now do the display
	 */
	
	rdf_include(chan);
	print_file(HOMEPATH"/html/toolbar.bottom");
	exit(0);
}

