/*
 *	Main portaloo generator functions
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h> 
#include <ctype.h>
#include <ftw.h>
#include "config.h"
#include "cgi.h"
#include "portaloo.h"

/*
 *	Global but try to pass it around for future neatness
 */
 
static char *binary="/cgi-bin/portaloo";



void portaloo_error(struct portaloo *p, char *t)
{
	issue_portaloo_cookie(p);
	printf("\n");
	printf("<H2>%s</H2>", t);
	exit(0);
}

/*
 *	Duplication isnt counted as an error, consider it a reload replay,
 *	it makes life much simpler for both ends.
 */
 
void add_group(struct portaloo *p, int group)
{
	int i=0;
	for(i=0;i<MAX_SUBSCRIBED;i++)
	{
		if(p->subscribed[i]==group)
			break;
		if(p->subscribed[i]==0)
		{
			p->subscribed[i]=group;
			if(i!=MAX_SUBSCRIBED)
				p->subscribed[i+1]=0;
			break;
		}
	}
}

void front_group(struct portaloo *p, int group)
{
	int i=0;
	int n;
	int v;
	for(i=0;i<MAX_SUBSCRIBED;i++)
	{
		if(p->subscribed[i]==group)
			break;
		if(p->subscribed[i]==0)
			return;
	}
	if(i==0)
		return;
	n=p->subscribed[i];
	for(v=i;v>0;v--)
	{
		p->subscribed[v]=p->subscribed[v-1];
	}
	p->subscribed[0]=n;
}

void leave_group(struct portaloo *p, int group)
{
	int i=0;
	for(i=0;i<MAX_SUBSCRIBED;i++)
	{
		if(p->subscribed[i]==group)
		{
			for(i=i+1;i<MAX_SUBSCRIBED;i++)
			{
				p->subscribed[i-1]=p->subscribed[i];
			}
			p->subscribed[31]=0;
			break;
		}
		if(p->subscribed[i]==0)
			break;
	}
}

int is_subscribed(struct portaloo *p, int group)
{
	int i=0;
	for(i=0;i<MAX_SUBSCRIBED;i++)
	{
		if(p->subscribed[i]==group)
			return 1;
		if(p->subscribed[i]==0)
			return 0;
	}
	return 0;
}

/*
 *	Render a group
 */
 
void render_group(struct portaloo *p, int g, int big)
{
	char path[256];
	char buf[256];
	FILE *f;
	
	snprintf(path, 256, "%s/%d.out", PORTALOO_BASE, g);
	f=fopen(path, "r");
	if(f==NULL)
	{
		printf("<TABLE width=\"99%%\" border=0 bgcolor=\"#000000\" cellpadding=0 cellspacing=0>\n");
		printf("<TR><TD valign=top><FONT color=\"white\" face=\"helvetica\">\n");
		if(!big)
		{
			printf("<A href=\"%s?do=leave&group=%d\">\n", binary,  g);
			printf("<IMG src=\"/pclose.gif\" align=right border=0>\n");
			printf("</A>\n");
		}
		printf("<b>Discontinued Service</b><br clear=all>\n");
		printf("</FONT></TD></TR>\n");
		printf("</TABLE>\n");
		printf("This service you subscribed to no is no longer available. We apologise for any inconvenience caused,\n");
		printf("<P><br>\n");
		return;
	}	
	printf("<TABLE width=\"99%%\" border=0 bgcolor=\"#000000\" cellpadding=0 cellspacing=0>\n");
	printf("<TR><TD valign=top><FONT color=\"white\" face=\"helvetica\">\n");
	if(!big)
	{
		printf("<A href=\"%s?do=leave&group=%d\">\n", binary, g);
		printf("<IMG src=\"/pclose.gif\" align=right border=0 alt=\"[X]\">\n");
		printf("</A>\n");
	}
	if(fgets(buf,256,f)==NULL)
		strcpy(buf,"");	/* FIXME - error page */
	if(fgets(path,256,f)==NULL)
		strcpy(path,"Error!");
	printf("<b><A href=\"%s\">", path);
	printf("<IMG src=\"/popen.gif\" align=left border=0 alt=\"[O]\">\n");
	printf("</A>%s</b><br clear=all>\n", buf);
	printf("</FONT></TD></TR>\n");
	printf("</TABLE><P>\n");
	while(fgets(buf, 256, f))
	{
		if(strcmp(buf,"--\n")==0)
			break;
		if((p->flags[0]&FLAGS0_SHOW_TEXT)|| big)
			printf("%s",buf);
	}
	while(fgets(buf, 256, f))
	{
		if(strcmp(buf,"--\n")==0)
		{
			if((p->flags[0]&FLAGS0_SHOW_LONG) || big)
				continue;
			printf("</UL></FONT>\n");
			break;
		}
		printf("%s", buf);
	}
	printf("<P><br>");
	if(big)
	{
		if(is_subscribed(p, g))
		{
			printf("<A href=\"%s?do=front&group=%d\">[On Front Page]</A>", binary, g);
			printf("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
			printf("<A href=\"%s?do=leave&group=%d\">[Unsubscribe]</A>", binary, g);
		}
		else
			printf("<A href=\"%s?do=join&group=%d\">[Subscribe]</A>", binary, g);
			
	}
	else printf("<P align=right><A href=\"%s?only=%d\">More...</A></P>\n", binary, g);
	fclose(f);
}

static int print_count = 0;

static int print_entry(const char *name, const struct stat *whocares, int jollyroger)
{
	int i;
	int n=strlen(name);
	FILE *fp;
	char *p;
	char buf[256];
	
//	i(jollyroger!=FTW_F)
//		return 0;
	if(n<4+strlen(PORTALOO_BASE) || strcmp(name+n-4, ".out"))
		return 0;
		
	p=strrchr(name, '/');
	if(p==NULL)
		return 0;
	sscanf(p+1, "%d.out", &i);
	
	fp=fopen(name, "r");
	if(fp==NULL)
		return 0;
	fgets(buf,256,fp);
	fclose(fp);
	if(!is_subscribed(&self,i))
	{
		printf("<OPTION value=%d>%s</OPTION>\n", i, buf);
		print_count++;
	}
	return 0;
}


static int join_entry(const char *name, const struct stat *whocares, int jollyroger)
{
	int i;
	int n=strlen(name);
	FILE *fp;
	char *p;
	char buf[256];
	
	if(n<4+strlen(PORTALOO_BASE) || strcmp(name+n-4, ".out"))
		return 0;
		
	p=strrchr(name, '/');
	if(p==NULL)
		return 0;
	sscanf(p+1, "%d.out", &i);
	
	fp=fopen(name, "r");
	if(fp==NULL)
		return 0;
	fgets(buf,256,fp);
	fclose(fp);
	if(!is_subscribed(&self,i))
		add_group(&self,i);
	return 0;
}

		
/*
 *	Again treat repeats as reload replays.
 */


int main(int argc, char *argv[])
{
	char *p;
	char *cmd = getenv("SCRIPT_NAME");
	time_t now;
	int i;
	int ct=0;
	int cols;
	int backtail = 0;
	FILE *fp;
	int idx = 0;

	load_secret();
		
	if(cmd == NULL)
	{
		fprintf(stderr, "Dude, you should be running %s as a cgi-bin\n",argv[0]);
		exit(0);	
	}
	if(strncmp(cmd,"/index.cgi", 10)==0)
	{
		binary="/index.cgi";
		idx=1;
	}
	if(strncmp(cmd,"/itest.cgi", 10)==0)
	{
		binary="/itest.cgi";
		idx=1;
	}
	if(strncmp(cmd,"/cgi-bin/portaloo-uc", 20)==0)
	{
		binary="/cgi-bin/portaloo-uc";
		idx=0;
		avoid_cache=1;
	}
	
	printf("Content-type: text/html\n");
	
	p=getenv("HTTP_COOKIE");
	if(p==NULL)
		init_portaloo(&self, "unset");
	else
	{
		switch(decode_portaloo_cookie(&self, p))
		{
			case -1:
			case 0:
				init_portaloo(&self, "broken");
				break;
			default:
		}
	}
	
	time(&now);
	self.laston = now;
	
	cgi_process();
		
	p=cgi_find("do");
	if(p && strcmp(p, "setname")==0)
	{
		p=cgi_find("newname");
		if(p!=NULL)
			strncpy(self.uname, p, 31);
	}
	else if(p && strcmp(p, "join")==0)
	{
		int num;
		p=cgi_find("group");
		if(p!=NULL && sscanf(p, "%d", &num)==1 && num>0 && num < 65535)
		{
			add_group(&self, num);
		}
	}
	else if(p && strcmp(p, "front")==0)
	{
		int num;
		p=cgi_find("group");
		if(p!=NULL && sscanf(p, "%d", &num)==1 && num>0 && num < 65535)
		{
			front_group(&self, num);
		}
	}
	else if(p && strcmp(p, "leave")==0)
	{
		int num;
		p=cgi_find("group");
		if(p!=NULL && sscanf(p, "%d", &num)==1 && num>0 && num < 65535)
		{
			leave_group(&self, num);
		}
	}
	else if(p && strcmp(p, "texton")==0)
	{
		self.flags[0]|=FLAGS0_SHOW_TEXT;
	}
	else if(p && strcmp(p, "textoff")==0)
	{
		self.flags[0]&=~FLAGS0_SHOW_TEXT;
	}
	else if(p && strcmp(p, "longon")==0)
	{
		self.flags[0]|=FLAGS0_SHOW_LONG;
	}
	else if(p && strcmp(p, "longoff")==0)
	{
		self.flags[0]&=~FLAGS0_SHOW_LONG;
	}

	if((p=cgi_find("addall"))!=NULL)
	{
		ftw(PORTALOO_BASE, join_entry, 1);
	}
	
	issue_portaloo_cookie(&self);
	printf("\n");

	/* Only mode is allowed with the front screen */
	
	if((p=cgi_find("only"))!=NULL)
		idx=0;
			
	switch(idx)
	{
		case 0:
			printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\" \"http://www.w3.org/TR/REC-html40/loose.dtd\">\n");

			printf("<HTML><HEAD>\n");
			printf("<TITLE>Linux Portaloo at %s</TITLE>", ctime(&now));
			printf("</HEAD>\n");
			printf("<BODY bgcolor=\"#ccccaa\">\n");
	
			if(avoid_cache)
				fp = fopen(PORTALOO_BASE"html/uchead.html", "r");
			else
				fp = fopen(PORTALOO_BASE"html/head.html", "r");
			if(fp)
			{
				char buf[256];
				while(fgets(buf,256,fp))
					printf("%s", buf);
				fclose(fp);
			}
			break;
		case 1:
			fp = fopen(PORTALOO_BASE"html/index.html.top", "r");
			if(fp)
			{
				char buf[256];
				while(fgets(buf,256,fp))
					printf("%s", buf);
				fclose(fp);
			}
			/* This drops out at the right handle table side */
			printf("<TABLE width=\"99%%\" border=0>\n");
			printf("<TR>");
			printf("<TD valign=top width=\"95%%\" bgcolor=\"#eeeebb\">\n");
			render_group(&self, self.subscribed[0], 0);
			printf("<P>\n");
			render_group(&self, self.subscribed[1], 0);
			printf("</TD></TR></TABLE>\n");
			fp = fopen(PORTALOO_BASE"html/index.html.bottom", "r");
			if(fp)
			{
				char buf[256];
				while(fgets(buf,256,fp))
					printf("%s", buf);
				fclose(fp);
			}
			return 0;
	}
	if((p=cgi_find("only"))!=NULL)
	{
		int v;
		sscanf(p, "%d", &v);
		printf("<TABLE width=\"99%%\" border=0>\n");
		printf("<TR>");
		printf("<TD valign=top width=\"95%%\" bgcolor=\"#eeeebb\">\n");
		render_group(&self, v, 1);
		printf("</TD></TR>\n");
		backtail=1;
		goto tail;
	}
	if((p=cgi_find("about"))!=NULL)
	{
		char buf[256];
		printf("<TABLE width=\"99%%\" border=0>\n");
		printf("<TR>");
		printf("<TD valign=top width=\"95%%\" bgcolor=\"#eeeebb\">\n");
		fp=fopen(PORTALOO_BASE"html/about.html", "r");
		if(fp!=NULL)
		{
			while(fgets(buf,256,fp)!=NULL)
				printf("%s",buf);
			fclose(fp);
		}
		printf("</TD></TR>\n");
		backtail=1;
		goto tail;
	}
	if((p=cgi_find("add"))!=NULL)
	{
		printf("<TABLE width=\"99%%\" border=0>\n");
		printf("<TR>");
		printf("<TD valign=top width=\"95%%\" bgcolor=\"#eeeebb\">\n");
		printf("<FORM method=\"post\" action=\"%s\">\n", binary);
		printf("<TABLE><TR><TD valign=top width=\"45%%\">\n");
		printf("The following services are currently available on the portaloo.\n");
		printf("</TD><TD width=\"50%%\">\n");
		printf("<SELECT name=only size=10 width=240>\n");
		print_count=0;
		ftw(PORTALOO_BASE, print_entry, 1);
		printf("</SELECT>\n");
		if(print_count==0)
			printf("<br>You are subscribed to all our services.\n");
		else
		{
			printf("<P align=right>\n");
			printf("<INPUT type=submit value=\"View\">\n");
			printf("</P>");
		}
		printf("</TD></TR></TABLE>\n");
		printf("</FORM>\n");
		printf("</TD></TR>\n");
		backtail=1;
		goto tail;
		
	}
	
	if((p=cgi_find("addall"))!=NULL)
	{
		ftw(PORTALOO_BASE, join_entry, 1);
	}
	
	if((p=cgi_find("feedback"))!=NULL)
	{
		printf("<TABLE width=\"99%%\" border=0>\n");
		printf("<TR>");
		printf("<TD valign=top width=\"95%%\" bgcolor=\"#eeeebb\" cellpadding=7>\n");
		printf("<FONT face=helvetica size=+2><u>Feedback</U></FONT><br>\n");
		printf("<FONT face=helvetica>Please send your feedback to <A href=\"mailto:alan@redhat.com\">Alan Cox</A>\n");
		printf("If you see problems be sure to include your browser type"
			" and version, as well as the OS you are running it on.\n");
		printf("<br><br><br><br></FONT>\n");
		printf("</TD></TR>\n");
		backtail=1;
		goto tail;
		
	}
	
	for(i=0;i< MAX_SUBSCRIBED;i++)
	{
		if(self.subscribed[i])
			ct++;
		else
			break;
	}
	
	/* Now figure the rendering rules */
	/* Rule we work to - 1->3 is that many wide, 4 is 2x2 otherwise use 3 */
	
	cols=3;
	if(ct<3)
		cols=ct;
	if(ct==4)
		cols=2;
		
	printf("<TABLE width=\"99%%\" border=0>\n");
	for(i=0;i<ct;i++)
	{
		if((i%cols)==0)
			printf("<TR>");
		printf("<TD valign=top width=\"%d%%\" bgcolor=\"#eeeebb\">\n", 99/cols);
		render_group(&self, self.subscribed[i], 0);
		printf("</TD>\n");
	}
tail:
	printf("</TABLE>\n");
	if(backtail)
	{
		printf("<CENTER><A href=\"%s\">[Back]</A></CENTER>\n", binary);
	}
	printf("</BODY>\n");
	return 0;
}
