typedef unsigned char	u8;
typedef unsigned short  u16;
typedef unsigned long  u32;

#define MAX_SUBSCRIBED	128

struct portaloo_v1
{
	u16	magic;
#define OLDPORTALOO_MAGIC	0xAB09
	u16	version;
#define OLDPORTALOO_VERSION 1	
	u16	subscribed[32];
	u16	flags[16];		/* 256 bits of flags */
	u8	uname[32];
	u32	laston;			/* Last login */
	u8	count[4];
};

struct portaloo
{
	u16	magic;
#define PORTALOO_MAGIC	0xAB09
	u16	version;
#define PORTALOO_VERSION 2
	u16	subscribed[128];
	u16	flags[32];		/* 256 bits of flags */
#define FLAGS0_LOGGED_IN	1
#define FLAGS0_SHOW_TEXT	2
#define FLAGS0_SHOW_LONG	4
#define FLAGS0_NAME_SET		8
#define FLAGS0_MD5_HASH		16	/* A hash is present in flags 8-15 */
#define FLAGS1_WEBTTY_PID		/* Webtty pid */
	u8	uname[32];
	u32	laston;			/* Last login */
	u8	count[16];
#define DEPTH_COUNT	0
#define POST_COUNT	1		/* Avoid dupes */
};

extern struct portaloo self;
extern int load_secret(void);
extern void init_portaloo(struct portaloo *, char *);
extern int check_portaloo(struct portaloo *);
extern void issue_portaloo_cookie(struct portaloo *);
extern int decode_portaloo_cookie(struct portaloo *, char *);
extern int avoid_cache;