#include <stdio.h>
#include <string.h>
#include <gdbm.h>

#include "config.h"
#include "struct.h"

int main(int argc, char **argv)
{
	GDBM_FILE db;
	datum key, data;
	char path[512];

	snprintf(path, 512, "%s/user.db", HOMEPATH);
	if ((db=gdbm_open(path, 1024, GDBM_WRCREAT, 0600, NULL))==NULL)
	{
		printf("Opening: %s\n", gdbm_strerror(gdbm_errno));
		exit(0);
	}

	key=gdbm_firstkey(db);
	while (key.dptr!=NULL)
	{
		printf("Key: '%s' (%d)", key.dptr, key.dsize);
		data=gdbm_fetch(db, key);
		if (data.dptr!=NULL)
			printf(" - Data '%s' (%d)", data.dptr, data.dsize);
		printf("\n");
		key=gdbm_nextkey(db,key);
	}
	gdbm_close(db);
}
